package com.csc349blum.readrawjson;

import java.io.InputStream;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import android.os.Bundle;
import android.app.Activity;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.Toast;

//JSON file from http://www.w3schools.com/json/

public class MainActivity extends Activity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        
Button btnRead = (Button) findViewById(R.id.btnRead);
        
        btnRead.setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				try{
					//http://stackoverflow.com/questions/6420293/reading-android-raw-text-file
					InputStream is = v.getResources().openRawResource(R.raw.employees);
				    byte[] buffer = new byte[is.available()];
				    while (is.read(buffer) != -1);
				    
				    String myText = new String(buffer);
					
				    //http://stackoverflow.com/questions/9605913/how-to-parse-json-in-android
				    //extract the main (top-level) JSON object from the file read above
				    JSONObject myJSON_object = new JSONObject(myText);
				    
				    //the main JSON object is/includes an array called employees
				    //extract that array
				    JSONArray myJSON_array = myJSON_object.getJSONArray("employees");
				    
				    //create a String array of employee full names 
				    String[] employee_full = new String[myJSON_array.length()];
				    for (int i=0; i < myJSON_array.length(); i++){
				    	try{
				    		//get an individual element of the JSON array
				    		JSONObject aJSON_element = myJSON_array.getJSONObject(i);
				    		//get the individual properties of the JSON element
				    		String fn = aJSON_element.getString("firstName");
				    		String ln = aJSON_element.getString("lastName");
				    		//make the employee full name
				    		employee_full[i] = fn + " " + ln;
				    	}
				    	catch (JSONException e) 
				    	{
				    		Toast.makeText(getBaseContext(), "Dude, you have to know what the JSON looks like to parse it", Toast.LENGTH_SHORT).show();
				    		e.printStackTrace();
				    	}
				    }
				    
				    //associate the full name with the listView
				    ListView lvEmployees = (ListView) findViewById(R.id.lvEmployees);
				    ArrayAdapter<String> adapter= new ArrayAdapter<String>(getBaseContext(),R.layout.tvemployee,employee_full);
				    lvEmployees.setAdapter(adapter);
				}
				catch(Exception e){
					Toast.makeText(getBaseContext(), "Problem with file", Toast.LENGTH_SHORT).show();
					e.printStackTrace();
				}  

			}//end onClick 
		});//end setOnClickListener
        
    } //end onCreate
} //end MainActivity class
